/*

    pygtkdial -- provides the gtkdial widget for pygtk

    Copyright (C) 1999  Eric S. Tiedemann

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Eric S. Tiedemann, est@hyperreal.org

*/

#include <python1.5/Python.h>
#include <gtk/gtk.h>

#include "gtkdial.h"

typedef PyObject *(*PGN)(GtkObject *go);

static PGN pgn;
static PyObject *gtkw;

/* euch */
typedef struct {
  PyObject_HEAD
  GtkObject *obj;
} PyGtk_Object;

static PyObject *pgot;


/* !!! need to clean up nicely on failure */
static PyObject *
pygtkdial_new(PyObject *self, PyObject *args)
{
  PyObject *pgdialt, *pgdialw;
  PyObject *o;
  GtkObject *adj;
  GtkWidget *d;

  if (!PyArg_ParseTuple(args, "O;pygtkdial.dial", &o))
    return 0;

  if (o->ob_type != pgot)
    return 0;

  adj = ((PyGtk_Object *) o)->obj;

  fprintf(stderr, "ghee\n");

  d = gtk_dial_new(GTK_ADJUSTMENT(adj));

  if (!d) return 0;

  fprintf(stderr, "ghee1\n");

  /* !!!ack..must check return values */
  pgdialt = Py_BuildValue("(O)", pgn(GTK_OBJECT(d)));

  if (!pgdialt)
    {
      return 0;
    }

  fprintf(stderr, "ghee2\n");

  pgdialw = PyEval_CallObject(gtkw, pgdialt);

  if (!pgdialw)
    {
      return 0;
    }

  fprintf(stderr, "ghee3\n");

  return pgdialw;
}

static PyMethodDef pygtkdialMethods[] =
{
  {"dial", pygtkdial_new, METH_VARARGS},
  {0, 0, 0}
};

void
initpygtkdial()
{
  PyObject *_gtkmod, *_gtkmodd, *_private, *pgncobj;
  PyObject *gtk;
  PyObject *gtkd;

  if (!(_gtkmod = PyImport_ImportModule("_gtk")))
    Py_FatalError("can't initialize oolalow");
  if (!(_gtkmodd = PyModule_GetDict(_gtkmod)))
    Py_FatalError("can't initialize oolalow");
  if (!(pgot = PyDict_GetItemString(_gtkmodd, "GtkObjectType")))
    Py_FatalError("can't initialize oolalow");
  if (!(_private = PyDict_GetItemString(_gtkmodd, "_private")))
    Py_FatalError("can't initialize oolalow");
  if (!(pgncobj = PyDict_GetItemString(_private, "PyGtk_New")))
    Py_FatalError("can't initialize oolalow");
  if (! PyCObject_Check(pgncobj))
    Py_FatalError("can't initialize oolalow");
  if (! (gtk = PyImport_ImportModule("gtk")))
    Py_FatalError("can't initialize oolalow");
  if (! (gtkd = PyModule_GetDict(gtk)))
    Py_FatalError("can't initialize oolalow");
  if (! (gtkw = PyDict_GetItemString(gtkd, "GtkWidget")))
    Py_FatalError("can't initialize oolalow");

  /* is this really needed? */
  Py_INCREF(gtkw);

  pgn = (PGN) PyCObject_AsVoidPtr(pgncobj);

  Py_InitModule("pygtkdial", pygtkdialMethods);
}
